using System;
using System.IO;
using System.Data;
using System.Data.OleDb;
using System.Configuration;

public partial class CS : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }

    protected void InsertExcel03(object sender, EventArgs e)
    {
        this.InsertExcelRow("E:\\Customers.xls");
    }

    protected void InsertExcel07(object sender, EventArgs e)
    {
        this.InsertExcelRow("E:\\Customers.xlsx");
    }

    private void InsertExcelRow(string filePath)
    {
        if (File.Exists(filePath))
        {
            string extension = Path.GetExtension(filePath);
            string conString = "";
            switch (extension)
            {
                case ".xls": //Excel 97-03
                    conString = ConfigurationManager.ConnectionStrings["Excel03ConString"].ConnectionString;
                    break;
                case ".xlsx": //Excel 07
                    conString = ConfigurationManager.ConnectionStrings["Excel07ConString"].ConnectionString;
                    break;
            }
            conString = string.Format(conString, filePath);
            using (OleDbConnection connExcel = new OleDbConnection(conString))
            {
                using (OleDbCommand cmdExcel = new OleDbCommand())
                {
                    cmdExcel.Connection = connExcel;
                    connExcel.Open();
                    //Check if the Sheet Exists.
                    using (DataTable dtExcelSchema = connExcel.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, null))
                    {
                        connExcel.Close();
                        DataRow[] dr = dtExcelSchema.Select("TABLE_NAME = 'Customers$'");

                        //If not Create the Sheet.
                        if (dr == null || dr.Length == 0)
                        {
                            cmdExcel.CommandText = "CREATE TABLE [Customers] (ID NVARCHAR(10), Name NVARCHAR(50), Country NVARCHAR(50));";
                            connExcel.Open();
                            cmdExcel.ExecuteNonQuery();
                            connExcel.Close();
                        }

                        connExcel.Open();

                        //Add New Row to Excel File.
                        cmdExcel.CommandText = "INSERT INTO [Customers$] (ID, Name, Country) VALUES ('1', 'John Hammond', 'United States')";
                        cmdExcel.ExecuteNonQuery();
                        connExcel.Close();
                    }
                }
            }
        }
    }

    protected void UpdateExcel03(object sender, EventArgs e)
    {
        this.UpdateExcelRow("E:\\Customers.xls");
    }

    protected void UpdateExcel07(object sender, EventArgs e)
    {
        this.UpdateExcelRow("E:\\Customers.xlsx");
    }

    private void UpdateExcelRow(string filePath)
    {
        if (File.Exists(filePath))
        {
            string extension = Path.GetExtension(filePath);
            string conString = "";
            switch (extension)
            {
                case ".xls": //Excel 97-03
                    conString = ConfigurationManager.ConnectionStrings["Excel03ConString"].ConnectionString;
                    break;
                case ".xlsx": //Excel 07
                    conString = ConfigurationManager.ConnectionStrings["Excel07ConString"].ConnectionString;
                    break;
            }
            conString = string.Format(conString, filePath);
            using (OleDbConnection connExcel = new OleDbConnection(conString))
            {
                using (OleDbCommand cmdExcel = new OleDbCommand())
                {
                    cmdExcel.Connection = connExcel;
                    connExcel.Open();
                    //Check if the Sheet Exists.
                    using (DataTable dtExcelSchema = connExcel.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, null))
                    {
                        connExcel.Close();
                        DataRow[] dr = dtExcelSchema.Select("TABLE_NAME = 'Customers$'");
                        if (dr != null || dr.Length > 0)
                        {
                            connExcel.Open();
                            cmdExcel.CommandText = "UPDATE [Customers$] SET [Name] = 'Mudassar Khan', [Country] = 'India' WHERE ID = '1'";
                            cmdExcel.ExecuteNonQuery();
                            connExcel.Close();
                        }
                    }
                }
            }
        }
    }
}
