﻿Imports System.IO
Imports System.Data
Imports System.Data.OleDb
Imports System.Configuration

Partial Class VB
    Inherits System.Web.UI.Page
    Protected Sub InsertExcel03(ByVal sender As Object, ByVal e As EventArgs)
        Me.InsertExcelRow("E:\Customers.xls")
    End Sub

    Protected Sub InsertExcel07(ByVal sender As Object, ByVal e As EventArgs)
        Me.InsertExcelRow("E:\Customers.xlsx")
    End Sub

    Private Sub InsertExcelRow(ByVal filePath As String)
        If File.Exists(filePath) Then
            Dim extension As String = Path.GetExtension(filePath)
            Dim conString As String = ""

            Select Case extension
                Case ".xls" 'Excel 97-03
                    conString = ConfigurationManager.ConnectionStrings("Excel03ConString").ConnectionString
                Case ".xlsx" 'Excel 07
                    conString = ConfigurationManager.ConnectionStrings("Excel07ConString").ConnectionString
            End Select

            conString = String.Format(conString, filePath)
            Using connExcel As OleDbConnection = New OleDbConnection(conString)
                Using cmdExcel As OleDbCommand = New OleDbCommand()
                    cmdExcel.Connection = connExcel
                    connExcel.Open()
                    'Check if the Sheet Exists.
                    Using dtExcelSchema As DataTable = connExcel.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, Nothing)
                        connExcel.Close()
                        Dim dr As DataRow() = dtExcelSchema.Select("TABLE_NAME = 'Customers$'")

                        'If not Create the Sheet.
                        If dr Is Nothing OrElse dr.Length = 0 Then
                            cmdExcel.CommandText = "CREATE TABLE [Customers] (ID VARCHAR(10), Name VARCHAR(50), Country VARCHAR(50));"
                            connExcel.Open()
                            cmdExcel.ExecuteNonQuery()
                            connExcel.Close()
                        End If

                        'Add New Row to Excel File.
                        connExcel.Open()
                        cmdExcel.CommandText = "INSERT INTO [Customers$] (ID, Name, Country) VALUES ('1', 'John Hammond', 'United States')"
                        cmdExcel.ExecuteNonQuery()
                        connExcel.Close()
                    End Using
                End Using
            End Using
        End If
    End Sub

    Protected Sub UpdateExcel03(ByVal sender As Object, ByVal e As EventArgs)
        Me.UpdateExcelRow("E:\Customers.xls")
    End Sub

    Protected Sub UpdateExcel07(ByVal sender As Object, ByVal e As EventArgs)
        Me.UpdateExcelRow("E:\Customers.xlsx")
    End Sub

    Private Sub UpdateExcelRow(ByVal filePath As String)
        If File.Exists(filePath) Then
            Dim extension As String = Path.GetExtension(filePath)
            Dim conString As String = ""
            Select Case extension
                Case ".xls" 'Excel 97-03
                    conString = ConfigurationManager.ConnectionStrings("Excel03ConString").ConnectionString
                Case ".xlsx" 'Excel 07
                    conString = ConfigurationManager.ConnectionStrings("Excel07ConString").ConnectionString
            End Select
            conString = String.Format(conString, filePath)
            Using connExcel As OleDbConnection = New OleDbConnection(conString)
                Using cmdExcel As OleDbCommand = New OleDbCommand()
                    cmdExcel.Connection = connExcel
                    connExcel.Open()
                    'Check if the Sheet Exists.
                    Using dtExcelSchema As DataTable = connExcel.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, Nothing)
                        connExcel.Close()
                        Dim dr As DataRow() = dtExcelSchema.Select("TABLE_NAME = 'Customers$'")
                        If dr IsNot Nothing OrElse dr.Length > 0 Then
                            connExcel.Open()
                            cmdExcel.CommandText = "UPDATE [Customers$] SET [Name] = 'Mudassar Khan', [Country] = 'India' WHERE ID = '1'"
                            cmdExcel.ExecuteNonQuery()
                            connExcel.Close()
                        End If
                    End Using
                End Using
            End Using
        End If
    End Sub
End Class
